#!/usr/bin/python

########################################################################
# ns-renewal.py
# (c) by Michael Stroeder, michael.stroeder@inka.de
########################################################################

Version='0.5.3'

########################################################################
# CGI-BIN zur Erneuern eines Zertikates fuer Netscape Navigator
# Das CGI-BIN muss ueber netscape-base-url+netscape-cert-renewal-url
# erreichbar sein:
# Eingabe (ueber URL):
#   Seriennummer eines Zertifikates in hexadezimaler Form,
#   max. 8-stellig (32 Bit)
# Ausgabe:
#   Ausgabe eines leeren HTML-Formulares zur Erneuerung des durch
#   die Seriennummer angegebenen Zertifikates
########################################################################

import sys, os, string, regex, htmlbase, cgiforms, charset, openssl

# Ausgabe der Ergebnistabelle
def PrintFound(found,cellpadding=5,width=100):

  print '<TABLE BORDER CELLPADDING=%d%% WIDTH=%d%%>' % (cellpadding,width)

  dnfield = openssl.SplitDN(found[openssl.DB_name])

  for i in dnfield.keys():
    if dnfield[i]:
      print '<TR><TD>%s</TD><TD>%s</TD></TR>' % (openssl.DN_text[i],charset.trans(dnfield[i],charset.t61,charset.html))

  print '</TABLE>'

# Ein paar Umgebungsvariablen auslesen, welche der Apache liefert
request_method  = os.environ['REQUEST_METHOD']
query_string    = os.environ['QUERY_STRING']

# Wir lesen rein gar nix von Standardeingabe => gleich dicht machen
sys.stdin.close()

# Hier die ueblichen Paranoid-Pruefungen der Parameter
if (request_method!='GET') or \
   (not query_string) or \
   (len(query_string)>8) or \
   (regex.match('[0-9a-fA-F]*',query_string)!=len(query_string)):
  # Skript nicht mit GET aufgerufen
  # Seriennummer mit mehr 32 Bit
  # Parameter war keine Hex-Nummer
  htmlbase.PrintErrorMsg('Angabe der Seriennummer fehlt oder war falsch.')
  sys.exit(0)

# Hex-String in Integer wandeln
serialnumber=string.atoi(query_string,16)

# Eintrag suchen lassen
entry = openssl.GetEntrybySerial(serialnumber)

# Dateinamen der SSLeay-Zertifikatliste
openssl.db_filename = '/usr/local/ssl/TestCA/index.txt'

# Zertifikat mit angegebener Nummer gefunden?
if not entry:
  htmlbase.PrintErrorMsg('Kein Zertifikat mit angegebener Seriennummer gefunden.')
  sys.exit(0)

# Legt der Client ein Zertifikat vor?
if os.environ.has_key('DN_NAME'):
  htmlbase.PrintErrorMsg('Ihre Software hat kein Zertifikat vorgelegt.')
  sys.exit(0)

# Passt vorgelegtes Zertifikat zur Seriennnummer?
if os.environ['DN_NAME']!=entry[openssl.DB_name]:
  htmlbase.PrintErrorMsg('Ihr Zertifikat passt nicht zur angegebenen Seriennummer.')
  sys.exit(0)

# Client hat das passende Client-Zertifikat vorgelegt

htmlbase.PrintHeader('Erneuerung eines Zertifikates')
htmlbase.PrintHeading('Erneuerung eines Zertifikates')
PrintHeading('Zertifikaterneuerung in Bearbeitung')
PrintFound(entry) 
htmlbase.PrintFooter()

sys.exit(0)
