#!/usr/bin/python

########################################################################
# ca-cycle-priv.py
# (c) by Michael Stroeder, michael.stroeder@inka.de
########################################################################

Version = '0.5.3'

########################################################################
# Process some modifications which involve private CA keys.
# This script is typically run by CRON or in a similar manner.
# It does several jobs:
# - Mark expired certificates in OpenSSL certificate database 
# - Process certificate requests
# - Process certificate revocation requests
# - Generate new CRLs, move old CRLs to archive
########################################################################

import sys, string, os, pycacnf, openssl

# Path to OpenSSL's config file
opensslcnf=openssl.cnf.OpenSSLConfigClass(pycacnf.cnf_filename)

pyca_section = opensslcnf.data.get('pyca',{})
ca_names = opensslcnf.sectionkeys.get('ca',[])

old_ca_databases = []

for ca_name in ca_names:

  sys.stdout.write('Processing CA "%s"\n' % (ca_name))

  ca_section=opensslcnf.data[opensslcnf.data['ca'][ca_name]]
  ca_dir = ca_section.get('dir','')
  ca_database = string.replace(ca_section.get('database','$dir/index.txt'),'$dir',ca_dir)

  if not ca_database in old_ca_databases:
    ca_db = openssl.db.OpenSSLcaDatabaseClass(ca_database)

  ########################################################################
  # Zyklische Manipulationen an der Zertifikatdatenbank
  ########################################################################

  if not ca_database in old_ca_databases:

    # Zertifikat-DB-Datei wurde noch nicht behandelt
    ca_db = openssl.db.OpenSSLcaDatabaseClass(ca_database)
    old_ca_databases.append(ca_database)

    ########################################################################
    # Abgelaufene Zertifikate als 'expired' markieren.
    ########################################################################

    ca_db.Expire()

  ########################################################################
  # Process certificate requests
  ########################################################################

  ########################################################################
  # Process certificate revocation requests
  ########################################################################

  ########################################################################
  # Generate new CRLs, move old CRLs to archive
  ########################################################################

