########################################################################
# pycacnf.py 
# (c) by Michael Stroeder, michael.stroeder@inka.de
########################################################################

Version='0.5.3'

########################################################################
# Some variables for configuration
########################################################################

# Full pathname of OpenSSL configuration file,
# most times named openssl.cnf
cnf_filename = '/etc/openssl/openssl.cnf'

# List of additional module directories
pylib = ['/usr/local/pyca/pylib','/home/michael/Proj/python/pyca/pylib']


########################################################################
# There's nothing to configure below this line
########################################################################

import sys,os

# Extend the Python path

try:
  # Python 1.5.2 :-)
  sys.path.extend(pylib)
except AttributeError:
  # Python 1.5.1 :-(
  for i in pylib:
    sys.path.append(i)

if os.path.isfile('%s.pickle' % (cnf_filename)):

  # Try to read OpenSSL's config file from a pickled copy
  try:
    # first try to use the faster cPickle module
    from cPickle import load
    f=open('%s.pickle' % (cnf_filename),'r')
    opensslcnf=load(f)
  except ImportError:
    # fall-back to standard pickle module
    try:
      from pickle import load
      f=open('%s.pickle' % (cnf_filename),'r')
      opensslcnf=load(f)
    except ImportError:
      # Read OpenSSL's config file from source
      import openssl
      opensslcnf=openssl.cnf.OpenSSLConfigClass(cnf_filename)

else:

  # Read OpenSSL's config file from source
  import openssl
  opensslcnf=openssl.cnf.OpenSSLConfigClass(cnf_filename)

# Diverse allgemeine Parameter aus der Sektion [ pyca ] bernehmen
pyca_section = opensslcnf.data.get('pyca',{})

import htmlbase

htmlbase.bodyPARAM=pyca_section.get('htmlBodyParam','')

ErrorLog = pyca_section.get('ErrorLog','')
if ErrorLog:
  # Fehlerprotokoll auf Datei umbiegen
  sys.stderr.close()
  sys.stderr = open(ErrorLog,'a')
